/*
 * UniqueFragments.hpp
 *
 *  Created on: Oct 18, 2011
 *      Author: heber
 */

#ifndef UNIQUEFRAGMENTS_HPP_
#define UNIQUEFRAGMENTS_HPP_

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <cstddef>
#include <vector>

class atom;
class Graph;
class KeySet;

/** Structure containing all values in power set combination generation.
 */
class UniqueFragments
{
public:
  UniqueFragments(
      double _TEFactor,
      std::vector<Graph*> &Leaflets,
      atom *_Root);
  ~UniqueFragments();

  void InsertFragmentIntoGraph(const size_t order); // Insert a KeySet into a Graph
  void Cleanup();

  atom * const getRoot() const;
  void setRoot(atom *_root);

  KeySet *FragmentSet;
  int FragmentCounter;

private:
  atom *Root;
  double TEFactor;
  std::vector<Graph*> &Leaflets;
};


#endif /* UNIQUEFRAGMENTS_HPP_ */
